-- Test add_amenity_carousel_slide
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(15);

set search_path to camper, public;

select has_function('camper', 'add_amenity_carousel_slide', array['integer', 'text', 'integer', 'text']);
select function_lang_is('camper', 'add_amenity_carousel_slide', array['integer', 'text', 'integer', 'text'], 'sql');
select function_returns('camper', 'add_amenity_carousel_slide', array['integer', 'text', 'integer', 'text'], 'integer');
select isnt_definer('camper', 'add_amenity_carousel_slide', array['integer', 'text', 'integer', 'text']);
select volatility_is('camper', 'add_amenity_carousel_slide', array['integer', 'text', 'integer', 'text'], 'volatile');
select function_privs_are('camper', 'add_amenity_carousel_slide', array['integer', 'text', 'integer', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'add_amenity_carousel_slide', array['integer', 'text', 'integer', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'add_amenity_carousel_slide', array['integer', 'text', 'integer', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'add_amenity_carousel_slide', array['integer', 'text', 'integer', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate amenity_carousel cascade;
truncate amenity cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
     , (2, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ff00ff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffff00","a"};')
     , ('text/plain', 'hello, world!')
     , ('image/svg+xml', '<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (3, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , (4, 2, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff00ff","a"};'))
     , (5, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffff00","a"};'))
     , (6, 1, 'text.txt', sha256('hello, world!'))
     , (7, 1, 'image.svg', sha256('<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>'))
;

insert into amenity (amenity_id, company_id, label, name)
values (11, 1, 'A1', 'Amenity A1')
     , (12, 1, 'Z9', 'Amenity Z9')
     , (13, 2, 'A1', 'Amenity A1')
;

insert into amenity_carousel (amenity_id, media_id, caption)
values (11, 5, 'A caption')
;

select lives_ok(
	$$ select add_amenity_carousel_slide(1, 'A1', 6, 'A caption') $$,
	'Should be able to add a carousel slide with a caption'
);

select lives_ok(
	$$ select add_amenity_carousel_slide(1, 'Z9', 7, null) $$,
	'Should be able to add a carousel slide without caption'
);

select lives_ok(
	$$ select add_amenity_carousel_slide(1, 'A1', 5, 'New caption') $$,
	'Should be able to overwrite a slide with a new caption'
);

select throws_ok(
	$$ select add_amenity_carousel_slide(1, 'A2', 3, '') $$,
	'23503', 'insert or update on table "amenity_carousel" violates foreign key constraint "amenity_carousel_amenity_id_fkey"',
	'Should raise an error if the label is not valid.'
);

select throws_ok(
	$$ select add_amenity_carousel_slide(3, 'A1', 3, '') $$,
	'23503', 'insert or update on table "amenity_carousel" violates foreign key constraint "amenity_carousel_amenity_id_fkey"',
	'Should raise an error if the company is not valid.'
);

select bag_eq(
	$$ select amenity_id, media_id, caption from amenity_carousel $$,
	$$ values (11, 5, 'New caption')
	        , (11, 6, 'A caption')
	        , (12, 7, '')
	$$,
	'Should have all three slides'
);

select *
from finish();

rollback;
